' CAB.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-01-07
' CAB.VBS manipulates CAB file in command line.
' Usage: CScript.exe CAB.VBS [-c|-e|-v] CABfile [files...]

Option Explicit
Const ssfBITBUCKET=10'shell:RecycleBinFolder::{645FF040-5081-101B-9F08-00AA002F954E}
Dim arg
Dim optind
Const Usage="Usage: CScript.exe CAB.VBS [-c|-d|-e|-v] CABfile [files...]"

If WScript.Arguments.Count<1 Then
  WScript.Echo Usage
  WScript.Quit
End If
arg=WScript.Arguments(optind)
If Left(arg,1)="-" Then
  Select Case LCase(arg)
  Case "-c","-a"
    optind=optind+1
    Call CreateCAB()
  Case "-d"
    optind=optind+1
    Call DeleteCAB()
  Case "-e","-x"
    optind=optind+1
    Call ExtractCAB()
  Case "-v","-l"
    optind=optind+1
    Call ListCAB()
  Case Else
    WScript.Echo "Invalid option -",arg&vbLf&Usage
    WScript.Quit
End Select
Else
  If WScript.Arguments.Count=1 Then
    Call ListCAB()
  Else
    Call CreateCAB()
  End If
End If
WScript.Quit

Sub CreateCAB()
Dim fso
Dim CABfile
Dim dic
Dim Path
Dim File
Dim MakeCab
Dim Shell
Dim zFolder
Dim zFolderItem
Dim tFolderName
Dim tFolder
Dim tFolderItem

If WScript.Arguments.Count<optind+2 Then
  WScript.Echo "Arguments Missing."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
CABfile=fso.GetAbsolutePathName(WScript.Arguments(optind))
If UCase(fso.GetExtensionName(CABfile))<>"CAB" Then
  WScript.Echo "Invalid Extension Name -",fso.GetFileName(CABfile)
  WScript.Quit
End If
Set dic=CreateObject("Scripting.Dictionary")
For optind=optind+1 To WScript.Arguments.Count-1
  Path=WScript.Arguments.Item(optind)
  File=LCase(fso.GetFileName(Path))
  If dic.Exists(File) Then
    WScript.Echo File,"- Duplicate Names."
    WScript.Quit
  End If
  If Not fso.FileExists(Path) Then
    WScript.Echo Path,"- Not Found."
    WScript.Quit
  End If
  Path=fso.GetAbsolutePathName(Path)
  dic.Add File,Path
Next
Set MakeCab=CreateObject("MakeCab.MakeCab.1") 
If fso.FileExists(CABfile) Then
  Set Shell=CreateObject("Shell.Application")
  Set zFolder=Shell.NameSpace(CABfile)
  tFolderName=fso.BuildPath(fso.GetParentFolderName(CABfile),fso.GetTempName)
  fso.CreateFolder tFolderName
  Set tFolder=Shell.NameSpace(tFolderName)
  For Each zFolderItem In zFolder.Items()
    If dic.Exists(LCase(fso.GetFileName(zFolderItem.Path))) Then
    Else
      tFolder.CopyHere zFolderItem
    End If
  Next
  Set zFolder=Nothing
  Shell.NameSpace(ssfBITBUCKET).MoveHere CABfile
  Do While fso.FileExists(CABfile)
    WScript.Sleep 100
  Loop
  MakeCab.CreateCab (CABfile),False,False,False 
  For Each tFolderItem In tFolder.Items()
    MakeCab.AddFile tFolderItem.Path,fso.GetFileName(tFolderItem.Path)
  Next
  fso.DeleteFolder tFolderName
Else
  MakeCab.CreateCab (CABfile),False,False,False 
End If
For Each File In dic
  MakeCab.AddFile (dic.Item(File)),(File)
Next
MakeCab.CloseCab 
End Sub

Sub DeleteCAB()
Dim fso
Dim CABfile
Dim dic
Dim Shell
Dim zFolder
Dim zFolderItem
Dim Path
Dim File
Dim tFolderName
Dim tFolder
Dim tFolderItem
Dim MakeCab

If WScript.Arguments.Count<optind+2 Then
  WScript.Echo "Arguments Missing."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
CABfile=WScript.Arguments(optind)
If UCase(fso.GetExtensionName(CABfile))<>"CAB" Then
  WScript.Echo "Invalid Extension Name -",fso.GetFileName(CABfile)
  WScript.Quit
End If
If Not fso.FileExists(CABfile) Then
  WScript.Echo "Not Found -",CABfile
  WScript.Quit
End If
CABfile=fso.GetAbsolutePathName(CABfile)
Set dic=CreateObject("Scripting.Dictionary")
Set Shell=CreateObject("Shell.Application")
Set zFolder=Shell.NameSpace(CABfile)
For Each zFolderItem In zFolder.Items()
  dic.Add LCase(fso.GetFileName(zFolderItem.Path)),1
Next
For optind=optind+1 To WScript.Arguments.Count-1
  Path=WScript.Arguments.Item(optind)
  File=LCase(Path)
  If dic.Exists(File) Then
    dic.Remove File
  Else
    WScript.Echo Path,"- Not Found."
    WScript.Quit
  End If
Next
tFolderName=fso.BuildPath(fso.GetParentFolderName(CABfile),fso.GetTempName)
fso.CreateFolder tFolderName
Set tFolder=Shell.NameSpace(tFolderName)
For Each zFolderItem In zFolder.Items()
  File=LCase(fso.GetFileName(zFolderItem.Path))
  If dic.Exists(File) Then
    tFolder.CopyHere zFolderItem
  End If
Next
Set zFolder=Nothing
Shell.NameSpace(ssfBITBUCKET).MoveHere CABfile
Do While fso.FileExists(CABfile)
  WScript.Sleep 100
Loop
Set MakeCab=CreateObject("MakeCab.MakeCab.1") 
MakeCab.CreateCab (CABfile),False,False,False 
For Each tFolderItem In tFolder.Items()
  Path=tFolderItem.Path
  File=fso.GetFileName(Path)
  MakeCab.AddFile (Path),(File)
Next
fso.DeleteFolder tFolderName
MakeCab.CloseCab 
End Sub

Sub ListCAB()
Dim fso
Dim CABfile
Dim Shell
Dim zFolder
Dim zFolderItem
Dim k
Dim COL:COL=4
Dim Cols
ReDim Cols(COL)
Dim Rows
Dim j

If WScript.Arguments.Count<optind+1 Then
  WScript.Echo "Arguments Missing."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
CABfile=WScript.Arguments(optind)
If UCase(fso.GetExtensionName(CABfile))<>"CAB" Then
  WScript.Echo "Invalid Extension Name -",fso.GetFileName(CABfile)
  WScript.Quit
End If
If Not fso.FileExists(CABfile) Then
  WScript.Echo "Not Found -",CABfile
  WScript.Quit
End If
CABfile=fso.GetAbsolutePathName(CABfile)
Set Shell=CreateObject("Shell.Application")
Set zFolder=Shell.NameSpace(CABfile)
ReDim rows(zFolder.Items.Count)
For k=0 To COL
  Cols(k)=zFolder.GetDetailsOf(,k)
Next
j=0
Rows(j)=Join(Cols,vbTab)
For Each zFolderItem In zFolder.Items
  For k=0 To COL
    Select Case k
    Case 0
      Cols(k)=fso.GetFileName(zFolderItem.Path)
    Case 1
      Cols(k)=zFolderItem.ExtendedProperty("Size")
    Case Else
      Cols(k)=zFolder.GetDetailsOf(zFolderItem,k)
    End Select
  Next
  j=j+1
  Rows(j)=Join(Cols,vbTab)
Next
WScript.Echo Join(Rows,vbLf)
End Sub

Sub ExtractCAB()
Dim fso
Dim Shell
Dim CABfile
Dim zFolder
Dim zFolderItem
Dim dFolder
Dim dic
Dim Path
Dim File

If WScript.Arguments.Count<optind+1 Then
  WScript.Echo "Arguments Missing."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
CABfile=WScript.Arguments(optind)
If UCase(fso.GetExtensionName(CABfile))<>"CAB" Then
  WScript.Echo "Invalid Extension Name -",fso.GetFileName(CABfile)
  WScript.Quit
End If
If Not fso.FileExists(CABfile) Then
  WScript.Echo "Not Found -",CABfile
  WScript.Quit
End If
CABfile=fso.GetAbsolutePathName(CABfile)
Set Shell=CreateObject("Shell.Application")
Set zFolder=Shell.NameSpace(CABfile)
Set dFolder=Shell.NameSpace(fso.GetAbsolutePathName(""))
If WScript.Arguments.Count<optind+2 Then
  dFolder.CopyHere zFolder.Items
Else
  Set dic=CreateObject("Scripting.Dictionary")
  For Each zFolderItem In zFolder.Items()
    dic.Add LCase(fso.GetFileName(zFolderItem.Path)),False
  Next
  For optind=optind+1 To WScript.Arguments.Count-1
    Path=WScript.Arguments.Item(optind)
    File=LCase(Path)
    If dic.Exists(File) Then
      dic.Item(File)=True
    Else
      WScript.Echo Path,"- Not Found."
      WScript.Quit
    End If
  Next
  For Each zFolderItem In zFolder.Items()
    File=LCase(fso.GetFileName(zFolderItem.Path))
    If dic.Item(File) Then
      dFolder.CopyHere zFolderItem
    End If
  Next
End If
End Sub
